HDU3486-RMQ

Interviewe

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6766    Accepted Submission(s): 1606


Problem Description
YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is  , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?
 

Input
The input consists of multiple cases.
In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
The input ends up with two negative numbers, which should not be processed as a case.
 

Output
For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.
 

Sample Input
11 300 7 100 7 101 100 100 9 100 100 110 110 -1 -1
 
Sample Output
3
Hint
We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.


题目大意:给你n个数,现在将n个数分成m组,每组的个数为n/m 求最小的m使得每组里面最大的数的和大于k,如果不存在就是输出-1

题目思路:求区间最大,如果暴力去求的话显然时间复杂度会非常大,所以我们就会想到用一种方法来预处理区间最值,所以就会想到RMQ-ST ,因为查询时的复杂度是O(1),所以当预处理玩区间最值后就可以去枚举组数,而在输入时可以求出总和和最大的数,如果总和都小于等于k就输出-1,如果最大值大于k就是1, 

否则就从max(2,k/max)开始枚举


AC代码:


#include<iostream>
#include<stdio.h>
#include<string.h>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
using namespace std;
#define N 200005
int M(int a,int b){
    return a>b?a:b;
}
int n,m;
int a[N];
int dp[N][20];

void RMQ()
{
   // int tmp=log((double)n)/log(2.0);
    for (int i=1;i<=n;i++)
    dp[i][0]=a[i];
    for (int j=1;j<=log(n)/log(2);j++)
    for (int i=1;i<=n;i++)
    if (i+(1<<j)-1<=n)
    dp[i][j]=M(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
}

int getmax(int l,int r)
{
    int k=log(r-l+1)/log(2.0);
    return M(dp[l][k],dp[r-(1<<k)+1][k]);
}

int main()
{
   while(scanf("%d%d",&n,&m)){
        if(n<0&&m<0)break;
       int Max = 0,sum=0;
       for(int i=1;i<=n;i++){
            scanf("%d",&a[i]);
            Max = M(Max,a[i]);
            sum+=a[i];
       }
       if(Max>m){printf("1\n");continue;}
       if(sum<=m){printf("-1\n");continue;}
       int ans = M(2,m/Max); RMQ();
       while(ans<n){
         sum=0;
         int x = n/ans;
         for(int i=1;i<=ans;i++){
            sum+=getmax((i-1)*x+1,i*x);
         }
         if(sum>m)break;
         ans++;
       }
       printf("%d\n",ans);

   }
    return 0;
}







全部评论

相关推荐

咦哟,从去年八月份开始长跑,两处实习转正都失败了,风雨飘摇,终于拿到offer了更新一下面试记录:秋招:多部门反复面试然后挂掉然后复活,具体问了啥已经忘了,只是被反复煎炸,直至焦香😋春招:base北京抖音hr打来电话说再次复活,准备面试,gogogo北京抖音一面:六道笔试题:1.promise顺序2.定义域问题3.flat展开4.并发请求5.岛屿数量算法(力扣)深度,广度都写6.忘记了,好像也是算法,难度中等其他问题多是框架底层设计,实习项目重难点~~~秒过😇北京抖音二面:三道笔试题:(为什么只有三道是因为第三道没做出来,卡住了)1.中等难度算法(忘记啥题了,应该是个数组的)2.认识js的继承本质(手写继承模式,深入js的面相对象开发)3.手写vue的响应式(卡在了watch,导致挂掉)---后知后觉是我的注册副作用函数写得有问题,有点紧张了其他题目多是项目拷打,项目亮点,对实习项目的贡献~~~第二天,挂,but立马复活转战深圳客服当天约面深圳客服一面:六道笔试题,由于面过太多次字节,面试官叫我直接写,不用讲,快些写完😋,具体都是些继承,深拷贝(注意对数组对象分开处理,深层次对象,循环引用),加中等难度算法题~~~秒过深圳客服二面:口诉八股大战:大概囊括网络,浏览器渲染原理,动画优化,时间循环,任务队列等等(你能想到的简单八股通通拉出来鞭尸😋)算法题:笔试题6道:1:找出数组内重复的数,arr[0]-arr[n]内的数大小为[1-n],例如[1,2,2,3,3]返回[2,3],要求o(n),且不使用任何额外空间(做到了o(n),空间方面欠佳,给面试官说进入下一题,做不来了)2:原滋原味的继承(所以继承真滴很重要)3:力扣股票购买时机难度中等其他滴也忘记了,因为拿到offer后鼠鼠一下子就落地了,脑子自动过滤掉可能会攻击鼠鼠的记忆😷~~~秒过深圳客服三面:项目大战参与战斗的人员有:成员1:表单封装及其底层原理,使用成本的优化,声明式表单成员2:公司内部库生命周期管理成员3:第三方库和内部库冲突如何源码断点调试并打补丁解决成员4:埋点的艺术成员5:线上项目捷报频传如何查出内鬼成员6:大文件分片的风流趣事成员7:设计模式对对碰成员8:我构建hooks应对经理的新增的小需求的故事可能项目回答的比较流利,笔试题3道,都很简单,相信大家应该都可以手拿把掐😇~~~过过过无hr面后续煎熬等待几天直接hr打电话发offer了,希望大家也可以拿到自己心仪的offer
法力无边年:牛哇,你真是准备得充分,我对你没有嫉妒,都是实打实付出
查看19道真题和解析
点赞 评论 收藏
分享
评论
点赞
收藏
分享

创作者周榜

更多
牛客网
牛客企业服务